import java.awt.*;

public class TicTacToe extends GUI
{   
    public static void main(String[] args)
    {  new TicTacToe(); }
    
    public TicTacToe()     // Constructor 
    {  super(600,600);   }

    Button b0 = addButton("",50,50,50,50,this);
    Button b1 = addButton("",100,50,50,50,this);
    Button b2 = addButton("",150,50,50,50,this);    
    Button b3 = addButton("",50,100,50,50,this);
    Button b4 = addButton("",100,100,50,50,this);
    Button b5 = addButton("",150,100,50,50,this);
    Button b6 = addButton("",50,150,50,50,this);
    Button b7 = addButton("",100,150,50,50,this);
    Button b8 = addButton("",150,150,50,50,this); 

    String player = "X";  // TOGGLE

    public void actions(Object source, String command)
    {      
        Button b = (Button)source ;

        if(b.getLabel().length() == 0)
        {
            b.setLabel(player);
            
            checkVictory();
            
            if(player.equals("X"))
            {  player = "O"; }
            else
            {  player = "X"; }   
        }
    }

    public void checkVictory()
    {
        match(b0,b1,b2," top row");
        match(b3,b4,b5," middle row");
        match(b6,b7,b8," bottom row");
        match(b0,b3,b6," left col");
        match(b1,b4,b7," mid col");
        match(b2,b5,b8," right col");
        match(b0,b4,b8,"d1");
        match(b2,b4,b6,"d2");
    }

    public void match(Button c1, Button c2, Button c3,String msg)
    {
        if(c1.getLabel().length() != 0)
        {
            if(c1.getLabel().equals(c2.getLabel()) && c2.getLabel().equals(c3.getLabel())) 
            {  output("Winner is " + player + " in " + msg); 
               System.exit(0);
            } 
        }
    }
}

/*****************************
(1) Move the "board" into the middle of the window,
    instead of the top left corner.
    
(2) Make the buttons bigger, maybe 200 pixels,
    to prepare for the next step.
    
(3) At the beginning, input the names of the
    2 players.  Then use these names instead
    of X and O.
    
(4) Make another button called [New Game].
    This erases the board. It should NOT
    change the current value in PLAYER.
    That way, the loser of the previous game
    gets to start the new game.
    
(5) Add variables to keep track of how many
    times each player wins.  You also need
    to DISPLAY these values somewhere.
    The best idea is to add a Label for each
    player's name, and then display their
    wins underneath that label.
    
(6) Make the program HIGHLIGHT the name of
    the player when it is their turn.
    
(7) Make the program STOP after 10 games
    have been played.  This must also count
    TIES, so the results might be 5 wins
    for player A, 1 win for player B, and 4 ties.
******************************/